import { Model } from 'sequelize-typescript';
import { CountOptions } from 'sequelize/types';

declare class HyperModel<T> extends Model<T> {
    static exists(options?: CountOptions): Promise<boolean>;
}
declare class HyperModelError extends Error {
    readonly isModelError = true;
    constructor(message?: string);
}
declare class ModelAssertionError extends Error {
    readonly isAssertionError = true;
    constructor(message?: string);
}

declare function UUIDPK(t: any, prop: string): void;

export { HyperModel, HyperModelError, ModelAssertionError, UUIDPK };
