import { ModelsOpts } from './types.js';
import 'sequelize-typescript';
import '@hyperstackjs/typings';
import 'sequelize';

declare const tableBuilder: {
    build: (...args: any) => any;
    uniqueConstraint: (name: string, fields: any, opts?: any) => any;
    intFK: (name: string, toTable: any, toKey: any, opts?: any) => {
        [x: string]: any;
    };
    intPK: (name: string, opts?: any) => {
        [x: string]: any;
    };
    json: (name: string, opts?: any) => {
        [x: string]: any;
    };
    text: (name: string, opts?: any) => {
        [x: string]: any;
    };
    string: (name: string, opts?: any) => {
        [x: string]: any;
    };
    nonNullString: (name: string, opts?: any) => {
        [x: string]: any;
    };
    uniqueString: (name: string, opts?: any) => {
        [x: string]: any;
    };
    date: (name: string, opts?: any) => {
        [x: string]: any;
    };
    nonNullDate: (name: string, opts?: any) => {
        [x: string]: any;
    };
    bool: (name: string, opts?: any) => {
        [x: string]: any;
    };
    int: (name: string, opts?: any) => {
        [x: string]: any;
    };
    nonNullInt: (name: string, opts?: any) => {
        [x: string]: any;
    };
    timestamps: (opts?: any) => {
        createdAt: any;
        updatedAt: any;
    };
};
declare const migrate: (cmd: 'auto' | 'pending' | 'reset' | 'to', _id?: string) => ({ migrationsRoot, logger, connection, }: Pick<ModelsOpts, 'migrationsRoot' | 'logger' | 'connection'>) => Promise<void>;

export { migrate, tableBuilder };
