var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/migrate.ts
var migrate_exports = {};
__export(migrate_exports, {
  migrate: () => migrate,
  tableBuilder: () => tableBuilder
});
module.exports = __toCommonJS(migrate_exports);
var import_sequelize = require("sequelize");
var import_lodash = __toESM(require("lodash"));
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hypermodel:migrate");
var tableBuilder = {
  build: (...args) => import_lodash.default.reduce(args, import_lodash.default.merge, {}),
  uniqueConstraint: (name, fields, opts) => __spreadValues({
    fields,
    type: "unique",
    name
  }, opts),
  intFK: (name, toTable, toKey, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.INTEGER,
      allowNull: false,
      references: {
        model: toTable,
        key: toKey
      }
    }, opts)
  }),
  intPK: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.INTEGER,
      allowNull: false,
      autoIncrement: true,
      primaryKey: true
    }, opts)
  }),
  json: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.JSON
    }, opts)
  }),
  text: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.TEXT
    }, opts)
  }),
  string: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.STRING
    }, opts)
  }),
  nonNullString: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.STRING,
      allowNull: false
    }, opts)
  }),
  uniqueString: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.STRING,
      allowNull: false,
      unique: true
    }, opts)
  }),
  date: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.DATE
    }, opts)
  }),
  nonNullDate: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.DATE,
      allowNull: false
    }, opts)
  }),
  bool: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.BOOLEAN
    }, opts)
  }),
  int: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.INTEGER
    }, opts)
  }),
  nonNullInt: (name, opts) => ({
    [name]: __spreadValues({
      type: import_sequelize.INTEGER,
      allowNull: false
    }, opts)
  }),
  timestamps: (opts) => ({
    createdAt: __spreadValues({
      type: import_sequelize.DATE,
      allowNull: false
    }, opts),
    updatedAt: __spreadValues({
      type: import_sequelize.DATE,
      allowNull: false
    }, opts)
  })
};
var logTransform = ({
  event,
  name,
  durationSeconds
}) => {
  if (event === "migrating") {
    return `===>    up   | ${name}`;
  } else if (event === "migrated") {
    return `             | ${name} (in ${durationSeconds}s)`;
  } else if (event === "reverting") {
    return `===>    down | ${name}`;
  } else if (event === "reverted") {
    return `             | ${name} (in ${durationSeconds}s)`;
  } else {
    return `${event}: ${name} (tbd)`;
  }
};
var migrate = (cmd, _id) => async ({
  migrationsRoot,
  logger,
  connection
}) => {
  const { Umzug, SequelizeStorage } = require("umzug");
  const migrationsPath = migrationsRoot;
  debug("migration root is:", migrationsPath);
  const storage = new SequelizeStorage({
    sequelize: connection
  });
  const umzug = new Umzug({
    storage,
    logger: __spreadProps(__spreadValues({}, logger), { info: (msg) => logger.info(logTransform(msg)) }),
    migrations: {
      glob: migrationsPath,
      resolve: ({ name, path, context }) => {
        const migration = require(path);
        const newContext = __spreadProps(__spreadValues({}, context), {
          query: connection.getQueryInterface(),
          t: tableBuilder
        });
        return {
          name,
          up: async () => await migration.up(newContext),
          down: async () => await migration.down(newContext)
        };
      }
    }
  });
  const { yellow, bold } = logger.colors;
  const pref = bold(yellow("models:"));
  logger.info(`${pref} === migrations: start ===`);
  await umzug.up();
  logger.info(`${pref} === migrations: done  ===`);
  if (cmd !== "auto") {
    await connection.close();
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  migrate,
  tableBuilder
});
