var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/models.ts
var models_exports = {};
__export(models_exports, {
  buildModels: () => buildModels
});
module.exports = __toCommonJS(models_exports);
var import_glob = __toESM(require("glob"));
var import_sequelize_typescript = require("sequelize-typescript");
var import_lodash = __toESM(require("lodash"));
var load = (patt) => import_glob.default.sync(patt).map((f) => {
  let mod = null;
  try {
    mod = require(f);
  } catch (e) {
    console.log(`error dynamically loading '${f}'
${e.toString()}`);
    throw e;
  }
  return mod.default || mod;
});
var isTrue = (val) => val === true || val === "true";
var POOL_MAX_DEFAULT = 5;
var POOL_MIN_DEFAULT = 1;
var POOL_ACQUIRE_DEFAULT = 3e4;
var POOL_IDLE_DEFAULT = 1e4;
var createSequelizeConfig = async ({
  logger,
  config,
  modelsRoot
}) => {
  var _a, _b, _c, _d;
  const models = import_lodash.default.reduce(load(modelsRoot), import_lodash.default.merge);
  const max_pool_connection = ((_a = config.pool) == null ? void 0 : _a.max) || POOL_MAX_DEFAULT;
  let min_pool_connection = ((_b = config.pool) == null ? void 0 : _b.min) || POOL_MIN_DEFAULT;
  if (min_pool_connection > max_pool_connection) {
    logger.error(`max_pool_connection: ${max_pool_connection} is smaller than min_pool_connection: ${min_pool_connection}. setting min=max`);
    min_pool_connection = max_pool_connection;
  }
  const uri = config.uri;
  return {
    uri,
    models,
    sequelizeConfig: {
      logging: config.logging,
      benchmark: isTrue(config.logging),
      native: config.native,
      ssl: config.ssl,
      models: import_lodash.default.values(models),
      pool: {
        max: max_pool_connection,
        min: min_pool_connection,
        acquire: ((_c = config.pool) == null ? void 0 : _c.acquire) || POOL_ACQUIRE_DEFAULT,
        idle: ((_d = config.pool) == null ? void 0 : _d.idle) || POOL_IDLE_DEFAULT
      }
    }
  };
};
var buildModels = async ({
  logger,
  config,
  modelsRoot
}) => {
  const { uri, sequelizeConfig, models } = await createSequelizeConfig({
    logger,
    config,
    modelsRoot
  });
  const connection = new import_sequelize_typescript.Sequelize(uri, sequelizeConfig);
  return { models, connection };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  buildModels
});
